unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: David Bremner <david@tethera.net>
To: notmuch@notmuchmail.org
Cc: David Bremner <david@tethera.net>
Subject: [PATCH 05/11] lib/parse-sexp: parse 'and', 'not', 'or'
Date: Tue, 13 Jul 2021 21:02:33 -0300	[thread overview]
Message-ID: <20210714000239.804384-6-david@tethera.net> (raw)
In-Reply-To: <20210714000239.804384-1-david@tethera.net>

This is not too useful yet, but provides gluing together queries in
various ways, which is actually one of the main motivations for
the s-expression query format.
---
 lib/Makefile.local        |  3 +-
 lib/parse-sexp.cc         | 72 +++++++++++++++++++++++++++++++++++++++
 lib/query.cc              |  7 ++--
 test/T080-search.sh       |  5 ---
 test/T081-sexpr-search.sh | 22 ++++++++++++
 5 files changed, 100 insertions(+), 9 deletions(-)
 create mode 100644 lib/parse-sexp.cc
 create mode 100755 test/T081-sexpr-search.sh

diff --git a/lib/Makefile.local b/lib/Makefile.local
index e2d4b91d..1378a74b 100644
--- a/lib/Makefile.local
+++ b/lib/Makefile.local
@@ -63,7 +63,8 @@ libnotmuch_cxx_srcs =		\
 	$(dir)/features.cc	\
 	$(dir)/prefix.cc	\
 	$(dir)/open.cc		\
-	$(dir)/init.cc
+	$(dir)/init.cc		\
+	$(dir)/parse-sexp.cc
 
 libnotmuch_modules := $(libnotmuch_c_srcs:.c=.o) $(libnotmuch_cxx_srcs:.cc=.o)
 
diff --git a/lib/parse-sexp.cc b/lib/parse-sexp.cc
new file mode 100644
index 00000000..eded98e7
--- /dev/null
+++ b/lib/parse-sexp.cc
@@ -0,0 +1,72 @@
+#include <xapian.h>
+#include "notmuch-private.h"
+#include "sexp.h"
+
+typedef struct  {
+    const char *name;
+    Xapian::Query::op xapian_op;
+    Xapian::Query initial;
+} _sexp_op_t;
+
+static _sexp_op_t operations[] =
+{
+    { "and",    Xapian::Query::OP_AND,          Xapian::Query::MatchAll },
+    { "not",    Xapian::Query::OP_AND_NOT,      Xapian::Query::MatchAll },
+    { "or",     Xapian::Query::OP_OR,           Xapian::Query::MatchNothing },
+    { }
+};
+
+static Xapian::Query _sexp_to_xapian_query (sexp_t *sx);
+
+static Xapian::Query
+_sexp_combine_query (Xapian::Query::op operation,
+		     Xapian::Query left,
+		     sexp_t *sx)
+{
+
+    /* if we run out elements, return accumulator */
+
+    if (! sx)
+	return left;
+
+    return _sexp_combine_query (operation,
+				Xapian::Query (operation,
+					       left,
+					       _sexp_to_xapian_query (sx)),
+				sx->next);
+}
+
+Xapian::Query
+_notmuch_sexp_string_to_xapian_query (notmuch_database_t *notmuch, const char *querystr)
+{
+    sexp_t *sx = NULL;
+    char *buf = talloc_strdup (notmuch, querystr);
+
+    sx = parse_sexp (buf, strlen (querystr));
+    return _sexp_to_xapian_query (sx);
+}
+
+/* Here we expect the s-expression to be a proper list, with first
+ * element defining and operation, or as a special case the empty
+ * list */
+
+static Xapian::Query
+_sexp_to_xapian_query (sexp_t *sx)
+{
+
+    const _sexp_op_t *op;
+
+    /* Currently we don't understand atoms */
+    assert (sx->ty == SEXP_LIST);
+
+    /* Empty list */
+    if (! sx->list)
+	return Xapian::Query::MatchAll;
+
+    for (op = operations; op && op->name; op++) {
+	if (strcasecmp (op->name, hd_sexp (sx)->val) == 0)
+	    return _sexp_combine_query (op->xapian_op, op->initial, sx->list->next);
+    }
+
+    INTERNAL_ERROR ("unimplemented prefix %s\n", sx->list->val);
+}
diff --git a/lib/query.cc b/lib/query.cc
index 9d2b6e50..6e89af60 100644
--- a/lib/query.cc
+++ b/lib/query.cc
@@ -20,11 +20,10 @@
 
 #include "notmuch-private.h"
 #include "database-private.h"
+#include "parse-sexp.h"
 
 #include <glib.h> /* GHashTable, GPtrArray */
 
-#include "sexp.h"
-
 typedef enum {
     NOTMUCH_QUERY_SYNTAX_XAPIAN,
     NOTMUCH_QUERY_SYNTAX_SEXPR,
@@ -192,7 +191,9 @@ _notmuch_query_ensure_parsed_xapian (notmuch_query_t *query)
 static notmuch_status_t
 _notmuch_query_ensure_parsed_sexpr (notmuch_query_t *query)
 {
-    query->xapian_query = Xapian::Query::MatchAll;
+
+    query->xapian_query = _notmuch_sexp_string_to_xapian_query (query->notmuch, query->query_string);
+
     return NOTMUCH_STATUS_SUCCESS;
 }
 
diff --git a/test/T080-search.sh b/test/T080-search.sh
index 966e772a..a3f0dead 100755
--- a/test/T080-search.sh
+++ b/test/T080-search.sh
@@ -189,9 +189,4 @@ test_begin_subtest "parts do not have adjacent term positions"
 output=$(notmuch search id:termpos and '"c x"')
 test_expect_equal "$output" ""
 
-test_begin_subtest "sexpr query: all messages"
-notmuch search '*' > EXPECTED
-notmuch search --query-syntax=sexp '()' > OUTPUT
-test_expect_equal_file EXPECTED OUTPUT
-
 test_done
diff --git a/test/T081-sexpr-search.sh b/test/T081-sexpr-search.sh
new file mode 100755
index 00000000..0b75334a
--- /dev/null
+++ b/test/T081-sexpr-search.sh
@@ -0,0 +1,22 @@
+#!/usr/bin/env bash
+test_description='"notmuch search" in several variations'
+. $(dirname "$0")/test-lib.sh || exit 1
+
+add_email_corpus
+
+for query in '()' '(not)' '(and)' '(or ())' '(or (not))' '(or (and))' \
+	     '(or (and) (or) (not (and)))'; do
+    test_begin_subtest "all messages: $query"
+    notmuch search '*' > EXPECTED
+    notmuch search --query-syntax=sexp "$query" > OUTPUT
+    test_expect_equal_file EXPECTED OUTPUT
+done
+
+for query in '(or)' '(not ())' '(not (not))' '(not (and))' \
+		    '(not (or (and) (or) (not (and))))'; do
+    test_begin_subtest "no messages: $query"
+    notmuch search --query-syntax=sexp "$query" > OUTPUT
+    test_expect_equal_file /dev/null OUTPUT
+done
+
+test_done
-- 
2.30.2

  parent reply	other threads:[~2021-07-14  0:03 UTC|newest]

Thread overview: 14+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-07-14  0:02 Early preview of s-expression based query parser David Bremner
2021-07-14  0:02 ` [PATCH 01/11] configure: optional library sfsexp David Bremner
2021-07-14  0:02 ` [PATCH 02/11] lib: split notmuch_query_create David Bremner
2021-07-14  0:02 ` [PATCH 03/11] lib: define notmuch_query_create_sexpr David Bremner
2021-07-14  0:02 ` [PATCH 04/11] CLI/search+address: support sexpr queries David Bremner
2021-07-14  0:02 ` David Bremner [this message]
2021-07-14  0:02 ` [PATCH 06/11] lib/parse-sexp: parse 'subject' David Bremner
2021-07-14  0:02 ` [PATCH 07/11] lib/parse-sexp: split terms in phrase mode David Bremner
2021-07-14  0:02 ` [PATCH 08/11] lib/parse-sexp: handle most fields David Bremner
2021-07-14  0:02 ` [PATCH 09/11] lib/parse-sexp: add error handling to internal API David Bremner
2021-07-14  0:02 ` [PATCH 10/11] lib/parse-sexp: add keyword arguments for fields David Bremner
2021-07-14  0:02 ` [PATCH 11/11] lib/parse-sexp: initial support for wildcard queries David Bremner
2021-07-16 14:00 ` Early preview of s-expression based query parser Hannu Hartikainen
2021-07-18 19:43   ` David Bremner

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20210714000239.804384-6-david@tethera.net \
    --to=david@tethera.net \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).